var $ = jQuery;
$(function() { 
	var tdClass = new Array();;
	var isFocusCell = false; // 
	
	// 
	function tdFocus(thisObj, thisClass){
		tdClass = thisClass.split(' ');
		$('.'+tdClass[0]).each(function(){
			$(this).css('background-color', '#f1f1f1');
		});
		$('.'+tdClass[1]).each(function(){
			$(this).css('background-color', '#f1f1f1');
		});
	}
	
	// 
	function tdUnFocus(thisObj){
		$('.'+tdClass[0]).each(function(){
			$(this).css('background-color', '#fff');
		});
		$('.'+tdClass[1]).each(function(){
			$(this).css('background-color', '#fff');
		});
	}
	
	function Rating($this) {
		// Получаем подмодуль
		var reg = /col_\d+/;
		var col = ''+reg.exec($this.attr('class'));
		col = $('.'+col+':first').attr('id');
		
		// Получаем студента
		var reg = /row_\d+/;
		var row = ''+reg.exec($this.attr('class'));
		row = $('.'+row+':first').attr('id');
		
		alert(col+' '+row+' '+$this.children('input').val());
		
		var edit = false; // Типа говорим, что балл нужно добавить, а не изменить
		if (-1 < $this.attr('class').indexOf('edit'))
			edit = true; // Типа изменить балл

		if (edit) {
			alert('changeRate');
			$.post('/~dev_rating/handler/rating/changeRate', {'student': row, 'submodule': col, 'rate': $this.children('input').val() },
				function(data){
					alert(data);
				}
			);
		}
		else {
			alert('setRate');
			$.post('/~dev_rating/handler/rating/setRate', {'student': row, 'submodule': col, 'rate': $this.children('input').val() },
				function(data){
					alert(data);
				}
			);
		}
	}
	
	$('.rateCell').mouseenter(function(){
		if (isFocusCell == false)
			tdFocus($(this), $(this).attr('class'));
	});
	
	$('.rateCell').mouseleave(function(){
		if (isFocusCell == false)
			tdUnFocus($(this));
	});
	
	$('.rateCell').focusin(function(){
		isFocusCell = true;
		tdFocus($(this), $(this).attr('class'));
	});
	
	$('.rateCell').focusout(function(){
		isFocusCell = false;
		tdUnFocus($(this));
		Rating($(this));
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$('.rateCell').children('input').keydown(function(event) {
        // Разрешаем: backspace, delete, tab и escape
        if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || 
             // Разрешаем: Ctrl+A
            (event.keyCode == 65 && event.ctrlKey === true) || 
             // Разрешаем: home, end, влево, вправо
            (event.keyCode >= 35 && event.keyCode <= 39)) {
                 // Ничего не делаем
                 return;
        }
        else {
            // Убеждаемся, что это цифра, и останавливаем событие keypress
            if ((event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                event.preventDefault(); 
            }   
        }
    });
	
});
